<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'sendImageColor' => '\\StructType\\SendImageColor',
            'sendImageColorResponse' => '\\StructType\\SendImageColorResponse',
            'insertUpdateResponse' => '\\StructType\\InsertUpdateResponse',
            'sendColor' => '\\StructType\\SendColor',
            'color' => '\\StructType\\Color',
            'sendColorResponse' => '\\StructType\\SendColorResponse',
            'sendSize' => '\\StructType\\SendSize',
            'size' => '\\StructType\\Size',
            'sendSizeResponse' => '\\StructType\\SendSizeResponse',
            'updatePackageInfo' => '\\StructType\\UpdatePackageInfo',
            'updatePackageInfoResponse' => '\\StructType\\UpdatePackageInfoResponse',
            'getOrders' => '\\StructType\\GetOrders',
            'getOrdersResponse' => '\\StructType\\GetOrdersResponse',
            'webOrdersReturn' => '\\StructType\\WebOrdersReturn',
            'order' => '\\StructType\\Order',
            'deliveredItemsAndCapturedPaymentInfo' => '\\StructType\\DeliveredItemsAndCapturedPaymentInfo',
            'orderLine' => '\\StructType\\OrderLine',
            'sendImage' => '\\StructType\\SendImage',
            'sendImageResponse' => '\\StructType\\SendImageResponse',
            'updateOrderStatus' => '\\StructType\\UpdateOrderStatus',
            'updateOrder' => '\\StructType\\UpdateOrder',
            'orderLineUpdate' => '\\StructType\\OrderLineUpdate',
            'updateOrderStatusResponse' => '\\StructType\\UpdateOrderStatusResponse',
            'updateOrderResponse' => '\\StructType\\UpdateOrderResponse',
            'getCreditApplicants' => '\\StructType\\GetCreditApplicants',
            'getCreditApplicantsResponse' => '\\StructType\\GetCreditApplicantsResponse',
            'creditApplicantsReturn' => '\\StructType\\CreditApplicantsReturn',
            'customer' => '\\StructType\\Customer',
            'getWelcomeMailTemplate' => '\\StructType\\GetWelcomeMailTemplate',
            'getWelcomeMailTemplateResponse' => '\\StructType\\GetWelcomeMailTemplateResponse',
            'mailTemplate' => '\\StructType\\MailTemplate',
            'getAllPaymentTypes' => '\\StructType\\GetAllPaymentTypes',
            'getAllPaymentTypesResponse' => '\\StructType\\GetAllPaymentTypesResponse',
            'getPaymentTypesResponse' => '\\StructType\\GetPaymentTypesResponse',
            'paymentType' => '\\StructType\\PaymentType',
            'greet' => '\\StructType\\Greet',
            'greetResponse' => '\\StructType\\GreetResponse',
            'sendArticle' => '\\StructType\\SendArticle',
            'article' => '\\StructType\\Article',
            'articleGroup' => '\\StructType\\ArticleGroup',
            'manufacturer' => '\\StructType\\Manufacturer',
            'productLine' => '\\StructType\\ProductLine',
            'sizeColor' => '\\StructType\\SizeColor',
            'stockDetail' => '\\StructType\\StockDetail',
            'sendArticleResponse' => '\\StructType\\SendArticleResponse',
            'getReceiptURL' => '\\StructType\\GetReceiptURL',
            'getReceiptURLResponse' => '\\StructType\\GetReceiptURLResponse',
            'updateStockCount' => '\\StructType\\UpdateStockCount',
            'updateStock' => '\\StructType\\UpdateStock',
            'updateStockCountResponse' => '\\StructType\\UpdateStockCountResponse',
            'removeAricle' => '\\StructType\\RemoveAricle',
            'removeAricleResponse' => '\\StructType\\RemoveAricleResponse',
            'sendDiscount' => '\\StructType\\SendDiscount',
            'discount' => '\\StructType\\Discount',
            'sendDiscountResponse' => '\\StructType\\SendDiscountResponse',
            'creditOrder' => '\\StructType\\CreditOrder',
            'creditOrderResponse' => '\\StructType\\CreditOrderResponse',
            'sendArticleGroup' => '\\StructType\\SendArticleGroup',
            'sendArticleGroupResponse' => '\\StructType\\SendArticleGroupResponse',
            'sendProductLine' => '\\StructType\\SendProductLine',
            'sendProductLineResponse' => '\\StructType\\SendProductLineResponse',
            'getArticleURL' => '\\StructType\\GetArticleURL',
            'getArticleURLResponse' => '\\StructType\\GetArticleURLResponse',
            'getOrderInfoURL' => '\\StructType\\GetOrderInfoURL',
            'getOrderInfoURLResponse' => '\\StructType\\GetOrderInfoURLResponse',
            'sendCustomerGroup' => '\\StructType\\SendCustomerGroup',
            'customerGroup' => '\\StructType\\CustomerGroup',
            'sendCustomerGroupResponse' => '\\StructType\\SendCustomerGroupResponse',
            'sendCustomerInfo' => '\\StructType\\SendCustomerInfo',
            'customerInfo' => '\\StructType\\CustomerInfo',
            'sendCustomerInfoResponse' => '\\StructType\\SendCustomerInfoResponse',
            'changeOrderLine' => '\\StructType\\ChangeOrderLine',
            'changeLine' => '\\StructType\\ChangeLine',
            'changeOrderLineResponse' => '\\StructType\\ChangeOrderLineResponse',
            'sendSizeColor' => '\\StructType\\SendSizeColor',
            'sendSizeColorResponse' => '\\StructType\\SendSizeColorResponse',
            'getStatus' => '\\StructType\\GetStatus',
            'getStatusResponse' => '\\StructType\\GetStatusResponse',
            'status' => '\\StructType\\Status',
            'createWebshop' => '\\StructType\\CreateWebshop',
            'webCompany' => '\\StructType\\WebCompany',
            'createWebshopResponse' => '\\StructType\\CreateWebshopResponse',
            'createDeltasWebshopResponse' => '\\StructType\\CreateDeltasWebshopResponse',
            'sendManufacturer' => '\\StructType\\SendManufacturer',
            'sendManufacturerResponse' => '\\StructType\\SendManufacturerResponse',
        );
    }
}
