<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for changeOrderLine StructType
 * Meta informations extracted from the WSDL
 * - type: tns:changeOrderLine
 * @subpackage Structs
 */
class ChangeOrderLine extends AbstractStructBase
{
    /**
     * The login
     * @var int
     */
    public $login;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The changeLine
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ChangeLine
     */
    public $changeLine;
    /**
     * Constructor method for changeOrderLine
     * @uses ChangeOrderLine::setLogin()
     * @uses ChangeOrderLine::setPassword()
     * @uses ChangeOrderLine::setChangeLine()
     * @param int $login
     * @param string $password
     * @param \StructType\ChangeLine $changeLine
     */
    public function __construct($login = null, $password = null, \StructType\ChangeLine $changeLine = null)
    {
        $this
            ->setLogin($login)
            ->setPassword($password)
            ->setChangeLine($changeLine);
    }
    /**
     * Get login value
     * @return int|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param int $login
     * @return \StructType\ChangeOrderLine
     */
    public function setLogin($login = null)
    {
        // validation for constraint: int
        if (!is_null($login) && !(is_int($login) || ctype_digit($login))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($login, true), gettype($login)), __LINE__);
        }
        $this->login = $login;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\ChangeOrderLine
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get changeLine value
     * @return \StructType\ChangeLine|null
     */
    public function getChangeLine()
    {
        return $this->changeLine;
    }
    /**
     * Set changeLine value
     * @param \StructType\ChangeLine $changeLine
     * @return \StructType\ChangeOrderLine
     */
    public function setChangeLine(\StructType\ChangeLine $changeLine = null)
    {
        $this->changeLine = $changeLine;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ChangeOrderLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
