<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createDeltasWebshopResponse StructType
 * @subpackage Structs
 */
class CreateDeltasWebshopResponse extends AbstractStructBase
{
    /**
     * The adminUserName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $adminUserName;
    /**
     * The adminUserPassword
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $adminUserPassword;
    /**
     * The deltasoftId
     * @var int
     */
    public $deltasoftId;
    /**
     * The insertUpdate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\InsertUpdateResponse
     */
    public $insertUpdate;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * Constructor method for createDeltasWebshopResponse
     * @uses CreateDeltasWebshopResponse::setAdminUserName()
     * @uses CreateDeltasWebshopResponse::setAdminUserPassword()
     * @uses CreateDeltasWebshopResponse::setDeltasoftId()
     * @uses CreateDeltasWebshopResponse::setInsertUpdate()
     * @uses CreateDeltasWebshopResponse::setPassword()
     * @param string $adminUserName
     * @param string $adminUserPassword
     * @param int $deltasoftId
     * @param \StructType\InsertUpdateResponse $insertUpdate
     * @param string $password
     */
    public function __construct($adminUserName = null, $adminUserPassword = null, $deltasoftId = null, \StructType\InsertUpdateResponse $insertUpdate = null, $password = null)
    {
        $this
            ->setAdminUserName($adminUserName)
            ->setAdminUserPassword($adminUserPassword)
            ->setDeltasoftId($deltasoftId)
            ->setInsertUpdate($insertUpdate)
            ->setPassword($password);
    }
    /**
     * Get adminUserName value
     * @return string|null
     */
    public function getAdminUserName()
    {
        return $this->adminUserName;
    }
    /**
     * Set adminUserName value
     * @param string $adminUserName
     * @return \StructType\CreateDeltasWebshopResponse
     */
    public function setAdminUserName($adminUserName = null)
    {
        // validation for constraint: string
        if (!is_null($adminUserName) && !is_string($adminUserName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($adminUserName, true), gettype($adminUserName)), __LINE__);
        }
        $this->adminUserName = $adminUserName;
        return $this;
    }
    /**
     * Get adminUserPassword value
     * @return string|null
     */
    public function getAdminUserPassword()
    {
        return $this->adminUserPassword;
    }
    /**
     * Set adminUserPassword value
     * @param string $adminUserPassword
     * @return \StructType\CreateDeltasWebshopResponse
     */
    public function setAdminUserPassword($adminUserPassword = null)
    {
        // validation for constraint: string
        if (!is_null($adminUserPassword) && !is_string($adminUserPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($adminUserPassword, true), gettype($adminUserPassword)), __LINE__);
        }
        $this->adminUserPassword = $adminUserPassword;
        return $this;
    }
    /**
     * Get deltasoftId value
     * @return int|null
     */
    public function getDeltasoftId()
    {
        return $this->deltasoftId;
    }
    /**
     * Set deltasoftId value
     * @param int $deltasoftId
     * @return \StructType\CreateDeltasWebshopResponse
     */
    public function setDeltasoftId($deltasoftId = null)
    {
        // validation for constraint: int
        if (!is_null($deltasoftId) && !(is_int($deltasoftId) || ctype_digit($deltasoftId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($deltasoftId, true), gettype($deltasoftId)), __LINE__);
        }
        $this->deltasoftId = $deltasoftId;
        return $this;
    }
    /**
     * Get insertUpdate value
     * @return \StructType\InsertUpdateResponse|null
     */
    public function getInsertUpdate()
    {
        return $this->insertUpdate;
    }
    /**
     * Set insertUpdate value
     * @param \StructType\InsertUpdateResponse $insertUpdate
     * @return \StructType\CreateDeltasWebshopResponse
     */
    public function setInsertUpdate(\StructType\InsertUpdateResponse $insertUpdate = null)
    {
        $this->insertUpdate = $insertUpdate;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\CreateDeltasWebshopResponse
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateDeltasWebshopResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
