<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for discount StructType
 * @subpackage Structs
 */
class Discount extends AbstractStructBase
{
    /**
     * The articleId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $articleId;
    /**
     * The category2Id
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $category2Id;
    /**
     * The categoryId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $categoryId;
    /**
     * The count
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $count;
    /**
     * The customerGroupId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $customerGroupId;
    /**
     * The customerId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $customerId;
    /**
     * The deleteDiscount
     * @var bool
     */
    public $deleteDiscount;
    /**
     * The discount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $discount;
    /**
     * The discountId
     * @var int
     */
    public $discountId;
    /**
     * The manufacturerId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $manufacturerId;
    /**
     * The priceAdjustment
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $priceAdjustment;
    /**
     * The priceType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $priceType;
    /**
     * The validUntil
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $validUntil;
    /**
     * Constructor method for discount
     * @uses Discount::setArticleId()
     * @uses Discount::setCategory2Id()
     * @uses Discount::setCategoryId()
     * @uses Discount::setCount()
     * @uses Discount::setCustomerGroupId()
     * @uses Discount::setCustomerId()
     * @uses Discount::setDeleteDiscount()
     * @uses Discount::setDiscount()
     * @uses Discount::setDiscountId()
     * @uses Discount::setManufacturerId()
     * @uses Discount::setPriceAdjustment()
     * @uses Discount::setPriceType()
     * @uses Discount::setValidUntil()
     * @param int $articleId
     * @param int $category2Id
     * @param int $categoryId
     * @param int $count
     * @param int $customerGroupId
     * @param int $customerId
     * @param bool $deleteDiscount
     * @param float $discount
     * @param int $discountId
     * @param int $manufacturerId
     * @param float $priceAdjustment
     * @param int $priceType
     * @param string $validUntil
     */
    public function __construct($articleId = null, $category2Id = null, $categoryId = null, $count = null, $customerGroupId = null, $customerId = null, $deleteDiscount = null, $discount = null, $discountId = null, $manufacturerId = null, $priceAdjustment = null, $priceType = null, $validUntil = null)
    {
        $this
            ->setArticleId($articleId)
            ->setCategory2Id($category2Id)
            ->setCategoryId($categoryId)
            ->setCount($count)
            ->setCustomerGroupId($customerGroupId)
            ->setCustomerId($customerId)
            ->setDeleteDiscount($deleteDiscount)
            ->setDiscount($discount)
            ->setDiscountId($discountId)
            ->setManufacturerId($manufacturerId)
            ->setPriceAdjustment($priceAdjustment)
            ->setPriceType($priceType)
            ->setValidUntil($validUntil);
    }
    /**
     * Get articleId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getArticleId()
    {
        return isset($this->articleId) ? $this->articleId : null;
    }
    /**
     * Set articleId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $articleId
     * @return \StructType\Discount
     */
    public function setArticleId($articleId = null)
    {
        // validation for constraint: int
        if (!is_null($articleId) && !(is_int($articleId) || ctype_digit($articleId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($articleId, true), gettype($articleId)), __LINE__);
        }
        if (is_null($articleId) || (is_array($articleId) && empty($articleId))) {
            unset($this->articleId);
        } else {
            $this->articleId = $articleId;
        }
        return $this;
    }
    /**
     * Get category2Id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCategory2Id()
    {
        return isset($this->category2Id) ? $this->category2Id : null;
    }
    /**
     * Set category2Id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $category2Id
     * @return \StructType\Discount
     */
    public function setCategory2Id($category2Id = null)
    {
        // validation for constraint: int
        if (!is_null($category2Id) && !(is_int($category2Id) || ctype_digit($category2Id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($category2Id, true), gettype($category2Id)), __LINE__);
        }
        if (is_null($category2Id) || (is_array($category2Id) && empty($category2Id))) {
            unset($this->category2Id);
        } else {
            $this->category2Id = $category2Id;
        }
        return $this;
    }
    /**
     * Get categoryId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCategoryId()
    {
        return isset($this->categoryId) ? $this->categoryId : null;
    }
    /**
     * Set categoryId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $categoryId
     * @return \StructType\Discount
     */
    public function setCategoryId($categoryId = null)
    {
        // validation for constraint: int
        if (!is_null($categoryId) && !(is_int($categoryId) || ctype_digit($categoryId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($categoryId, true), gettype($categoryId)), __LINE__);
        }
        if (is_null($categoryId) || (is_array($categoryId) && empty($categoryId))) {
            unset($this->categoryId);
        } else {
            $this->categoryId = $categoryId;
        }
        return $this;
    }
    /**
     * Get count value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCount()
    {
        return isset($this->count) ? $this->count : null;
    }
    /**
     * Set count value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $count
     * @return \StructType\Discount
     */
    public function setCount($count = null)
    {
        // validation for constraint: int
        if (!is_null($count) && !(is_int($count) || ctype_digit($count))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($count, true), gettype($count)), __LINE__);
        }
        if (is_null($count) || (is_array($count) && empty($count))) {
            unset($this->count);
        } else {
            $this->count = $count;
        }
        return $this;
    }
    /**
     * Get customerGroupId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCustomerGroupId()
    {
        return isset($this->customerGroupId) ? $this->customerGroupId : null;
    }
    /**
     * Set customerGroupId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $customerGroupId
     * @return \StructType\Discount
     */
    public function setCustomerGroupId($customerGroupId = null)
    {
        // validation for constraint: int
        if (!is_null($customerGroupId) && !(is_int($customerGroupId) || ctype_digit($customerGroupId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($customerGroupId, true), gettype($customerGroupId)), __LINE__);
        }
        if (is_null($customerGroupId) || (is_array($customerGroupId) && empty($customerGroupId))) {
            unset($this->customerGroupId);
        } else {
            $this->customerGroupId = $customerGroupId;
        }
        return $this;
    }
    /**
     * Get customerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCustomerId()
    {
        return isset($this->customerId) ? $this->customerId : null;
    }
    /**
     * Set customerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $customerId
     * @return \StructType\Discount
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: int
        if (!is_null($customerId) && !(is_int($customerId) || ctype_digit($customerId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($customerId, true), gettype($customerId)), __LINE__);
        }
        if (is_null($customerId) || (is_array($customerId) && empty($customerId))) {
            unset($this->customerId);
        } else {
            $this->customerId = $customerId;
        }
        return $this;
    }
    /**
     * Get deleteDiscount value
     * @return bool|null
     */
    public function getDeleteDiscount()
    {
        return $this->deleteDiscount;
    }
    /**
     * Set deleteDiscount value
     * @param bool $deleteDiscount
     * @return \StructType\Discount
     */
    public function setDeleteDiscount($deleteDiscount = null)
    {
        // validation for constraint: boolean
        if (!is_null($deleteDiscount) && !is_bool($deleteDiscount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($deleteDiscount, true), gettype($deleteDiscount)), __LINE__);
        }
        $this->deleteDiscount = $deleteDiscount;
        return $this;
    }
    /**
     * Get discount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getDiscount()
    {
        return isset($this->discount) ? $this->discount : null;
    }
    /**
     * Set discount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $discount
     * @return \StructType\Discount
     */
    public function setDiscount($discount = null)
    {
        // validation for constraint: float
        if (!is_null($discount) && !(is_float($discount) || is_numeric($discount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($discount, true), gettype($discount)), __LINE__);
        }
        if (is_null($discount) || (is_array($discount) && empty($discount))) {
            unset($this->discount);
        } else {
            $this->discount = $discount;
        }
        return $this;
    }
    /**
     * Get discountId value
     * @return int|null
     */
    public function getDiscountId()
    {
        return $this->discountId;
    }
    /**
     * Set discountId value
     * @param int $discountId
     * @return \StructType\Discount
     */
    public function setDiscountId($discountId = null)
    {
        // validation for constraint: int
        if (!is_null($discountId) && !(is_int($discountId) || ctype_digit($discountId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($discountId, true), gettype($discountId)), __LINE__);
        }
        $this->discountId = $discountId;
        return $this;
    }
    /**
     * Get manufacturerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getManufacturerId()
    {
        return isset($this->manufacturerId) ? $this->manufacturerId : null;
    }
    /**
     * Set manufacturerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $manufacturerId
     * @return \StructType\Discount
     */
    public function setManufacturerId($manufacturerId = null)
    {
        // validation for constraint: int
        if (!is_null($manufacturerId) && !(is_int($manufacturerId) || ctype_digit($manufacturerId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($manufacturerId, true), gettype($manufacturerId)), __LINE__);
        }
        if (is_null($manufacturerId) || (is_array($manufacturerId) && empty($manufacturerId))) {
            unset($this->manufacturerId);
        } else {
            $this->manufacturerId = $manufacturerId;
        }
        return $this;
    }
    /**
     * Get priceAdjustment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getPriceAdjustment()
    {
        return isset($this->priceAdjustment) ? $this->priceAdjustment : null;
    }
    /**
     * Set priceAdjustment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $priceAdjustment
     * @return \StructType\Discount
     */
    public function setPriceAdjustment($priceAdjustment = null)
    {
        // validation for constraint: float
        if (!is_null($priceAdjustment) && !(is_float($priceAdjustment) || is_numeric($priceAdjustment))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($priceAdjustment, true), gettype($priceAdjustment)), __LINE__);
        }
        if (is_null($priceAdjustment) || (is_array($priceAdjustment) && empty($priceAdjustment))) {
            unset($this->priceAdjustment);
        } else {
            $this->priceAdjustment = $priceAdjustment;
        }
        return $this;
    }
    /**
     * Get priceType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getPriceType()
    {
        return isset($this->priceType) ? $this->priceType : null;
    }
    /**
     * Set priceType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $priceType
     * @return \StructType\Discount
     */
    public function setPriceType($priceType = null)
    {
        // validation for constraint: int
        if (!is_null($priceType) && !(is_int($priceType) || ctype_digit($priceType))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($priceType, true), gettype($priceType)), __LINE__);
        }
        if (is_null($priceType) || (is_array($priceType) && empty($priceType))) {
            unset($this->priceType);
        } else {
            $this->priceType = $priceType;
        }
        return $this;
    }
    /**
     * Get validUntil value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getValidUntil()
    {
        return isset($this->validUntil) ? $this->validUntil : null;
    }
    /**
     * Set validUntil value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $validUntil
     * @return \StructType\Discount
     */
    public function setValidUntil($validUntil = null)
    {
        // validation for constraint: string
        if (!is_null($validUntil) && !is_string($validUntil)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($validUntil, true), gettype($validUntil)), __LINE__);
        }
        if (is_null($validUntil) || (is_array($validUntil) && empty($validUntil))) {
            unset($this->validUntil);
        } else {
            $this->validUntil = $validUntil;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Discount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
