<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for mailTemplate StructType
 * @subpackage Structs
 */
class MailTemplate extends AbstractStructBase
{
    /**
     * The footer
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $footer;
    /**
     * The header
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $header;
    /**
     * The mesage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $mesage;
    /**
     * Constructor method for mailTemplate
     * @uses MailTemplate::setFooter()
     * @uses MailTemplate::setHeader()
     * @uses MailTemplate::setMesage()
     * @param string $footer
     * @param string $header
     * @param string $mesage
     */
    public function __construct($footer = null, $header = null, $mesage = null)
    {
        $this
            ->setFooter($footer)
            ->setHeader($header)
            ->setMesage($mesage);
    }
    /**
     * Get footer value
     * @return string|null
     */
    public function getFooter()
    {
        return $this->footer;
    }
    /**
     * Set footer value
     * @param string $footer
     * @return \StructType\MailTemplate
     */
    public function setFooter($footer = null)
    {
        // validation for constraint: string
        if (!is_null($footer) && !is_string($footer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($footer, true), gettype($footer)), __LINE__);
        }
        $this->footer = $footer;
        return $this;
    }
    /**
     * Get header value
     * @return string|null
     */
    public function getHeader()
    {
        return $this->header;
    }
    /**
     * Set header value
     * @param string $header
     * @return \StructType\MailTemplate
     */
    public function setHeader($header = null)
    {
        // validation for constraint: string
        if (!is_null($header) && !is_string($header)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($header, true), gettype($header)), __LINE__);
        }
        $this->header = $header;
        return $this;
    }
    /**
     * Get mesage value
     * @return string|null
     */
    public function getMesage()
    {
        return $this->mesage;
    }
    /**
     * Set mesage value
     * @param string $mesage
     * @return \StructType\MailTemplate
     */
    public function setMesage($mesage = null)
    {
        // validation for constraint: string
        if (!is_null($mesage) && !is_string($mesage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mesage, true), gettype($mesage)), __LINE__);
        }
        $this->mesage = $mesage;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MailTemplate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
