<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for updateOrderStatus StructType
 * Meta informations extracted from the WSDL
 * - type: tns:updateOrderStatus
 * @subpackage Structs
 */
class UpdateOrderStatus extends AbstractStructBase
{
    /**
     * The login
     * @var int
     */
    public $login;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The updateOrder
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\UpdateOrder
     */
    public $updateOrder;
    /**
     * Constructor method for updateOrderStatus
     * @uses UpdateOrderStatus::setLogin()
     * @uses UpdateOrderStatus::setPassword()
     * @uses UpdateOrderStatus::setUpdateOrder()
     * @param int $login
     * @param string $password
     * @param \StructType\UpdateOrder $updateOrder
     */
    public function __construct($login = null, $password = null, \StructType\UpdateOrder $updateOrder = null)
    {
        $this
            ->setLogin($login)
            ->setPassword($password)
            ->setUpdateOrder($updateOrder);
    }
    /**
     * Get login value
     * @return int|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param int $login
     * @return \StructType\UpdateOrderStatus
     */
    public function setLogin($login = null)
    {
        // validation for constraint: int
        if (!is_null($login) && !(is_int($login) || ctype_digit($login))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($login, true), gettype($login)), __LINE__);
        }
        $this->login = $login;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\UpdateOrderStatus
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get updateOrder value
     * @return \StructType\UpdateOrder|null
     */
    public function getUpdateOrder()
    {
        return $this->updateOrder;
    }
    /**
     * Set updateOrder value
     * @param \StructType\UpdateOrder $updateOrder
     * @return \StructType\UpdateOrderStatus
     */
    public function setUpdateOrder(\StructType\UpdateOrder $updateOrder = null)
    {
        $this->updateOrder = $updateOrder;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UpdateOrderStatus
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
